################ CREATION JEUX PYTHON , NOTE
from time import *
from random import *
from tkinter import Tk , Canvas , font, Button
from PIL import Image , ImageTk
from winsound import PlaySound , SND_PURGE , SND_ASYNC

################ CODE PRINCIPAL
def creer_fenetre() :
    fenetre = Tk()
    fenetre.title("Projet Python , Jeux")                                                       # Fonction qui permet de créer une fenêtre tkinter et de la nommer , ici Projet Python Jeux
    return fenetre

def creer_widgets():
    global chiffre,zone_graphique
    
    zone_graphique = Canvas(fenetre, width=1000, height=600 , bg = 'black')
    zone_graphique.grid(row = 0 , column = 0 , columnspan = 3 )
    
    fond =ImageTk.PhotoImage(Image.open("fond.jpg") , master = fenetre)
    num_fond = zone_graphique.create_image(0, 0 , anchor = "nw" , image = fond) 
                                                                                                # Fonction creer_widgets qui nous permet de creer une zone graphique de 1000x600PX
                                                                                                # Qui crée Aussi un fond personnalisé ajouté dans le dossier
    bouton_valider = Button(fenetre, text = "Rejouer" , width = 12, command = rejouer)          # Création du bouton rejouer
    bouton_valider.grid(row = 1,column=2)                                                       # Ajout d'un systeme de score qui augmente au fil de la partie
    textescore = "Score : "+str(chiffre)
    zone_graphique.create_text(100,550, text=textescore,font="Helvetica 34 bold",fill="white")
    return zone_graphique, bouton_valider,num_fond,fond
    
    
def graphique_jeu(w,h):
    a = 150
    b = 250
    carre1 = zone_graphique.create_rectangle(a, b , a+w, b+h , fill = "blue")                   # Création des 4 carrés tous avec une couleur différente et des coordonnées différentes
    carre2 = zone_graphique.create_rectangle(a+200, b , a+w+200, b+h , fill = "white")
    carre3 = zone_graphique.create_rectangle(650, 350 , 550, 250 , fill = "red")
    carre4 = zone_graphique.create_rectangle(850, 350 , 750, 250 , fill = "green")
    carre=[carre1,carre2,carre3,carre4]
    return carre
    
    

                                                                                                                        
def hasard():                                                                                   # Création de la fonction hasard qui joue 4 sons au hasard avec randint  
    global cp,cptTemps,temps
    cp = cp + 1
    a = randint(0,3)
    cptTemps = 0
    if a == 0:
        PlaySound("Son-numéro-1.wav",SND_ASYNC)
        reponse.append(0)
        vibre(0)
    if a == 1:
        PlaySound("Son-numéro-2.wav",SND_ASYNC)
        reponse.append(1)
        vibre(1)
    if a == 2:
        PlaySound("Son-numéro-3.wav",SND_ASYNC)
        reponse.append(2)
        vibre(2)
    if a == 3:
        PlaySound("Son-numéro-4.wav",SND_ASYNC)
        reponse.append(3)
        vibre(3)
    if cp < 4 : fenetre.after(temps,hasard)
    
    

def son1(event):
    global textefin,reponse,liste2,chiffre,zone_graphique
    x_click = event.x
    y_click = event.y
    x_min = 150
    y_min = 250
    x_max = 250
    y_max = 350
    if  y_click > y_min and y_click < y_max:
        if x_click > 150 and x_click < 250 :
            PlaySound("Son-numéro-1.wav",SND_ASYNC)
            liste2.append(0)
        if x_click > 350 and x_click < 450 :
            PlaySound("Son-numéro-2.wav",SND_ASYNC)
            liste2.append(1)
        if x_click > 550 and x_click < 650 :
            PlaySound("Son-numéro-3.wav",SND_ASYNC)
            liste2.append(2)
        if x_click > 750 and x_click < 850 :
            PlaySound("Son-numéro-4.wav",SND_ASYNC)
            liste2.append(3)
    if liste2 == reponse:
        messagefin = "Bravo tu as gagné :)"
        zone_graphique = Canvas(fenetre, width=1000, height=600 , bg = 'white')
        zone_graphique.grid(row = 0 , column = 0 , columnspan = 3 )
        zone_graphique.create_text(500,300, text=messagefin,font="Helvetica 34 bold")
        PlaySound("son_gagne.wav",SND_ASYNC)
        return zone_graphique
    if len(liste2)==4 and liste2 != reponse:
        messagefin = "Tu as perdu :("
        zone_graphique = Canvas(fenetre, width=1000, height=600 , bg = 'red')
        zone_graphique.grid(row = 0 , column = 0 , columnspan = 3 )
        zone_graphique.create_text(500,300, text=messagefin,font="Helvetica 34 bold")
        PlaySound("son_perdu.wav",SND_ASYNC)
        texteperduscore = "Ton score est de : "+str(chiffre)
        zone_graphique.create_text(500,400, text=texteperduscore,font="Helvetica 34 bold",fill="black")
        return zone_graphique
        
def vibre(i) :
    global dx,cptTemps,delai
    num = carre[i]
    dx = -dx
    x0,y0,x1,y1 = zone_graphique.coords(num)
    zone_graphique.coords(num,x0-dx,y0-dx,x1+dx,y1+dx )
    cptTemps = cptTemps + 1
    if cptTemps<10 : fenetre.after(delai, lambda : vibre(i))
    
def rejouer():
    global cp,dx,cptTemps,carre,zone_graphique,bouton_valider,son1,textefin,reponse,liste2,chiffre,temps,delai,fond,score
    if liste2 == reponse:
        chiffre = chiffre + 1
        temps = temps - 100
        delai = delai - 10
        reponse = []
        liste2=[]
        zone_graphique, bouton_valider,num_fond,fond = creer_widgets()
        carre = graphique_jeu(100,100)
        cp = 0
        dx = 5
        cptTemps = 0
        PlaySound(None, SND_PURGE)   
        hasard()
        zone_graphique.bind("<ButtonPress-1>",son1)
    elif len(liste2)==4 and liste2 != reponse:
        temps = 1000
        delai = 100
        chiffre = 0
        reponse = []
        liste2=[]
        zone_graphique, bouton_valider,num_fond,fond = creer_widgets()
        carre = graphique_jeu(100,100)
        cp = 0
        dx = 5
        cptTemps = 0
        PlaySound(None, SND_PURGE)   
        hasard()
        zone_graphique.bind("<ButtonPress-1>",son1)
    elif chiffre == 10:
        zone_graphique, bouton_valider,num_fond,fond = creer_widgets()
        textefin = "Bravo tu as fini le jeu :)"
        zone_graphique.create_text(500,300, text=textefin,font="Helvetica 34 bold",fill="white")
        fenetre.after(10000)
        destroy()

    
    

################ MAIN
cp = 0
dx = 5
cptTemps = 0
chiffre = 0
temps = 1000
delai = 100
reponse = []
liste2=[]
liste = ["Son-numéro-1.wav","Son-numéro-2.wav","Son-numéro-3.wav","Son-numéro-4.wav"]
fenetre = creer_fenetre()
zone_graphique, bouton_valider,num_fond,fond = creer_widgets()
carre = graphique_jeu(100,100)
PlaySound(None, SND_PURGE)
hasard()
zone_graphique.bind("<ButtonPress-1>",son1)
fenetre.mainloop()